#include "DSP28x_Project.h"


void delay_loop(void);
void spi_xmit(Uint16 a);
void spi_fifo_init(void);
void spi_init(void);
void error(void);


Uint16 sdata;
Uint16 rdata = 0x00;
Uint16 rxdata = 0x00;
Uint16 phy_data = 0x00;
Uint16 phy_data2 = 0x00;
Uint16 version_data = 0x00;
Uint16 Mr_status = 0x00;
Uint16 GAR_data = 0x00;
Uint16 status = 0x00;
Uint16 status_listen = 0x00;
Uint16 cmdRegStat = 0x00;
Uint16 int_stat = 0x00;
Uint16 int_send_stat = 0x00;
Uint16 cmdRegStat_aft = 0x00;
Uint16 cmd_statFinal = 0x00;
Uint16 status_2 = 0x00;
Uint16 protocol = 0x00;
Uint16 src_port = 0x00;
Uint16 src_port2 = 0x00;
Uint16 tx_size = 0x00;
Uint16 tx_fsr = 0xFF;
Uint16 tx_fsr1 = 0xFF;
Uint16 tx_fsrval = 0x00;
Uint16 tx_wr = 0xFF;
Uint16 tx_wr1 = 0xff;
Uint16 tx_wrval = 0x00;
Uint16 tx_rD = 0xFF;
Uint16 tx_rD1 = 0xFF;
Uint16 tx_rDval = 0x00;
Uint16 offSet = 0x00;
Uint16 offset1 = 0x00;
Uint16 offset2 = 0x00;
Uint16 Tx_RD = 0x00;
Uint16 incr_addr = 0x00;
Uint16 incr_addr1 = 0x00;
Uint16 incr_addr2 = 0x00;
Uint8 i;
Uint16 spi_data[4]={0,};
Uint16 port[5];
Uint16 TX_RD[4];
Uint16 TX_WR[5];
Uint16 Tx_buffSize[10];
Uint16 Gar_data[7]={0,};
Uint16 SHAR_data[9]={0,};
Uint16 Dest_IP[7] = {0,};
Uint16 tmp = 0xFF;
void wiznetinit(void);
void main(void)
{

   InitSysCtrl();

   InitSpiaGpio();

   DINT;


   InitPieCtrl();


   IER = 0x0000;
   IFR = 0x0000;

   InitPieVectTable();

   spi_fifo_init();	  // Initialize the Spi FIFO
   spi_init();		  // init SPI


//for(;;)
//{

	   rdata = 0x00;
// reading version register value (0x04)
		 spi_data[0] = 0x00;													//#
		 spi_data[1] = 0x39;													//#
		 spi_data[2] = 0x00;													//#
		 spi_data[3] = 0x00;													//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<4;i++)														//#
		 {																		//#     reading version register value (0x04)
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
		version_data = SpiaRegs.SPIDAT;											//#
		DELAY_US(10);
		//version_data = 0x00;
//}

// Reading PHYCFGR reg
		 spi_data[0] = 0x00;													//#
		 spi_data[1] = 0x2E;													//#
		 spi_data[2] = 0x00;													//#
		 spi_data[3] = 0x00;													//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<4;i++)														//#
		 {																		//#     Reading PHYCFGR reg
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
		phy_data = SpiaRegs.SPIDAT;												//#
		DELAY_US(10);															//#

while(phy_data != 0xBF);

// Writing MR register for internal register initialization
		spi_data[0] = 0x00;														//#
		spi_data[1]	= 0x00;														//#
		spi_data[2] = 0x04;														//#
		spi_data[3] = 0x80;														//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<4;i++)														//#    Writing MR register for internal register initialization
		 {																		//#
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#

		DELAY_US(80);


//Writing GAR

		Gar_data[0] = 0x00;														//#
		Gar_data[1]	= 0x01;														//#
		Gar_data[2] = 0x04;														//#
		Gar_data[3] = 0xC0;		//192											//#
		Gar_data[4]	= 0xA8;		//168											//#
		Gar_data[5] = 0x01;		//1												//#
		Gar_data[6] = 0x01;		//1												//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#    Writing GAR
		 for (i=0;i<7;i++)														//#
		 {																		//#
			 SpiaRegs.SPITXBUF = (Gar_data[i]<<8);		//send frame			//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		// rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(49);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#

		DELAY_US(10);



//Writing SUBR reg

	/*Gar_data[0] = 0x00;														//#
	Gar_data[1]	= 0x05;															//#
	Gar_data[2] = 0x04;															//#
	Gar_data[3] = 0xFF;															//#
	Gar_data[4]	= 0xFF;															//#
	Gar_data[5] = 0xFF;															//#
	Gar_data[6] = 0x00;															//#
	 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low							//#
	 for (i=0;i<7;i++)															//#      Writing SUBR reg
	 {																			//#
		 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame				//#
	 }																			//#
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 		//#
	 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data				//#
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 		//#
	 DELAY_US(49);																//#
	GpioDataRegs.GPBSET.bit.GPIO57 = 1;											//#

	DELAY_US(10);*/

//Writing SHAR reg

/*	SHAR_data[0] = 0x00;														//#
	SHAR_data[1] = 0x09;														//#
	SHAR_data[2] = 0x04;														//#
	SHAR_data[3] = 0x00;														//#
	SHAR_data[4] = 0x08;														//#
	SHAR_data[5] = 0xDC;														//#
	SHAR_data[6] = 0x01;														//#
	SHAR_data[7] = 0x02;														//#
	SHAR_data[8] = 0x03;														//#
	 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low							//#        Writing SHAR reg
	 for (i=0;i<9;i++)															//#
	 {																			//#
		 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame				//#
	 }																			//#
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 		//#
	 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data				//#
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 		//#
	 DELAY_US(59);																//#
	GpioDataRegs.GPBSET.bit.GPIO57 = 1;											//#

	DELAY_US(10);*/

// WRITING Sipr Register


	Gar_data[0] = 0x00;															//#
	Gar_data[1]	= 0x0F;															//#
	Gar_data[2] = 0x04;															//#
	Gar_data[3] = 0xC0;		//192												//#
	Gar_data[4]	= 0xA8;		//168												//#
	Gar_data[5] = 0x01;		//1													//#
	Gar_data[6] = 0x02;		//2													//#
	 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low							//#
	 for (i=0;i<7;i++)															//#      WRITING Sipr Register
	 {																			//#
		 SpiaRegs.SPITXBUF = (Gar_data[i]<<8);		//send frame				//#
	 }																			//#
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 		//#
	 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data				//#
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 		//#
	 DELAY_US(49);																//#
	GpioDataRegs.GPBSET.bit.GPIO57 = 1;											//#
																				//#
	DELAY_US(10);																//#


// Writing Sn_Mr  register
		 spi_data[0] = 0x00;													//#
		 spi_data[1] = 0x00;													//#
		 spi_data[2] = 0x0C;													//#
		 spi_data[3] = 0x21;													//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<4;i++)														//#
		 {																		//#     Socket n mode register
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
																				//#
		DELAY_US(10);


//reading Sn_Mr  register
		spi_data[0] = 0x00;														//#
		spi_data[1] = 0x00;														//#
		spi_data[2] = 0x08;														//#
		spi_data[3] = 0x00;														//#
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low							//#
		for (i=0;i<4;i++)														//#
			 {																	//#     Socket n mode register(0001)
				SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame		//#
			 }																	//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		//rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		DELAY_US(29);															//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
		protocol = SpiaRegs.SPIDAT;												//#
		DELAY_US(10);



// Sn_Port register



		 port[0] = 0x00;														//#
		 port[1] = 0x04;														//#
		 port[2] = 0x0C;														//#
		 port[3] = 0x03;	//port num = 10000	(0x03E8)						//#
		 port[4] = 0xE8;														//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<5;i++)														//#
		 {																		//#     source port num
			 SpiaRegs.SPITXBUF = (port[i]<<8);		//send frame				//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(38);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
																				//#
		DELAY_US(10);


//open command Sn_Cr register

		 spi_data[0] = 0x00;													//#
		 spi_data[1] = 0x01;													//#
		 spi_data[2] = 0x0C;													//#
		 spi_data[3] = 0x01;				//open command						//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<4;i++)														//#
		 {																		//#     open command
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
																				//#
		DELAY_US(80);

// reading command register

		spi_data[0] = 0x00;														//#
		spi_data[1] = 0x01;														//#
		spi_data[2] = 0x08;														//#
		spi_data[3] = 0x00;														//#
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low							//#
		for (i=0;i<4;i++)														//#
				 {																//#     reading command reg
					 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame	//#		expected value (0x00)
				 }																//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
				 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data //#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
		cmdRegStat = SpiaRegs.SPIDAT;											//#
		DELAY_US(10);

while (cmdRegStat !=0x00);

//reading status register

		 spi_data[0] = 0x00;													//#
		 spi_data[1] = 0x03;													//#
		 spi_data[2] = 0x08;													//#
		 spi_data[3] = 0x00;													//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<4;i++)														//#
		 {																		//#     reading status reg
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#     expected value (0x13) {Sock_init}
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
		status = SpiaRegs.SPIDAT;												//#
		DELAY_US(10);

while(status != 0x13);


// Reading PHYCFGR reg
		spi_data[0] = 0x00;														//#
		spi_data[1] = 0x2E;														//#
		spi_data[2] = 0x00;														//#
		spi_data[3] = 0x00;														//#
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low							//#
		for (i=0;i<4;i++)														//#
		{																		//#     Reading PHYCFGR reg
			SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
		}																		//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
	 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data				//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
	 DELAY_US(29);																//#
	 GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
	 phy_data = SpiaRegs.SPIDAT;												//#
	 DELAY_US(10);																//#

//Set destionation Ip address ###################################################
/*
		Dest_IP[0] = 0x00;														//#
		Dest_IP[1] = 0x0F;														//#
		Dest_IP[2] = 0x0C;														//#
		Dest_IP[3] = 0xC0;														//#
		Dest_IP[4] = 0xA8;														//#
		Dest_IP[5] = 0x01;														//#
		Dest_IP[6] = 0x01;														//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<7;i++)														//#      WRITING DESTIP Register
		 {																		//#
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(49);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
																				//#
		DELAY_US(10);

//Set Destination port num    ########################################################

		 port[0] = 0x00;														//#
		 port[1] = 0x10;														//#
		 port[2] = 0x0C;														//#
		 port[3] = 0x13;														//#
		 port[4] = 0x88;														//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<5;i++)														//#
		 {																		//#     destination  port num
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(38);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
																				//#
		DELAY_US(10);

	// reading phy stat2________^^^^^^^^^^^^^^^^^^_________________________________
	 spi_data[0] = 0x00;														//#
	 spi_data[1] = 0x2E;														//#
	 spi_data[2] = 0x00;														//#
	 spi_data[3] = 0x00;														//#
	 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low							//#
	 for (i=0;i<4;i++)															//#
	 {																			//#     Reading PHYCFGR reg
		 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame				//#
	 }																			//#
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 		//#
	 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data				//#
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 		//#
	 DELAY_US(29);																//#
	GpioDataRegs.GPBSET.bit.GPIO57 = 1;											//#
	phy_data2 = SpiaRegs.SPIDAT;												//#
	DELAY_US(10);			*/													//#




// reading Sn_Port register (first byte)

	 		 port[0] = 0x00;													//#
	 		 port[1] = 0x04;													//#
	 		 port[2] = 0x08;													//#
	 		 port[3] = 0x00;													//#
	 		 //port[4] = 0x00;													//#
	 		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low					//#
	 		 for (i=0;i<4;i++)													//#
	 		 {																	//#     reading source port num	1
	 			 SpiaRegs.SPITXBUF = (port[i]<<8);		//send frame			//#
	 		 }																	//#
	 		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
	 		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data		//#
	 		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
	 		 DELAY_US(29);														//#
	 		GpioDataRegs.GPBSET.bit.GPIO57 = 1;									//#
	 		src_port = (SpiaRegs.SPIDAT)<<8;									//#
	 		DELAY_US(10);

// reading Sn_Port register  (2nd byte)

	 		port[0] = 0x00;														//#
	 		port[1] = 0x05;														//#
	 		port[2] = 0x08;														//#
	 		port[3] = 0x00;														//#
	 		//port[4] = 0x00;													//#
	 		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
	 		for (i=0;i<4;i++)													//#
	 			{																//#     reading source port num 2
	 			 	SpiaRegs.SPITXBUF = (port[i]<<8);	//send frame			//#
	 			}																//#
	 			 		 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
	 		//rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data		//#
	 			 		 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
	 		DELAY_US(29);														//#
	 		GpioDataRegs.GPBSET.bit.GPIO57 = 1;									//#
	 		src_port2 = SpiaRegs.SPIDAT;										//#
	 		DELAY_US(10);

src_port = src_port + src_port2;




while(phy_data != 0xBF);


// listen/connect command register (Sn_CR)

		 spi_data[0] = 0x00;													//#				@@@@@@@@@@
		 spi_data[1] = 0x01;													//#				@  		 @
		 spi_data[2] = 0x0C;													//#				@  		 @
		 spi_data[3] = 0x02;													//#				@  		 @
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#				@  		 @
		 for (i=0;i<4;i++)														//#				@  		 @
		 	 {																	//# writing listen 0x02(server)/
			 	 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame		/#	connect(0x04)(client) command to
		 	 }																//# Command register		 @
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#				@  		 @
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#				@  		 @
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#				@  		 @
		 DELAY_US(29);															//#				@  		 @
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#				@  		 @
																				//#				@@@@@@@@@@
		DELAY_US(800000);



// reading command register

				 spi_data[0] = 0x00;											//#
				 spi_data[1] = 0x01;											//#
				 spi_data[2] = 0x08;											//#
				 spi_data[3] = 0x00;											//#
				 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low				//#
				 for (i=0;i<4;i++)												//#
				 {																//#     reading command reg
					 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame	//#		expected value (0x00)
				 }																//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
				// rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data	//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
				 DELAY_US(29);													//#
				GpioDataRegs.GPBSET.bit.GPIO57 = 1;								//#
				cmdRegStat_aft = SpiaRegs.SPIDAT;								//#
				DELAY_US(10);
				status_2 = SpiaRegs.SPIDAT;

while (cmdRegStat_aft !=0x00 );

// Read Status register
while (status_listen != 0x17)
	{
		 spi_data[0] = 0x00;													//#
		 spi_data[1] = 0x03;													//#
		 spi_data[2] = 0x08;													//#
		 spi_data[3] = 0x00;													//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<4;i++)														//#
		 {																		//#     reading status reg
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#     expected value (0x14) {listen}
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
		status_listen = SpiaRegs.SPIDAT;										//#
		DELAY_US(10);
	}


// reading interupt register

		 spi_data[0] = 0x00;													//#
		 spi_data[1] = 0x02;													//#
		 spi_data[2] = 0x08;													//#
		 spi_data[3] = 0x00;													//#
		 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
		 for (i=0;i<4;i++)														//#
		 {																		//#     reading interrupt reg
			 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#     expected value (##) {listen}
		 }																		//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		// rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
		 DELAY_US(29);															//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
		int_stat = SpiaRegs.SPIDAT;												//#
		DELAY_US(10);

while(status_listen != 0x17);

// Setting TX_Buffer size

		spi_data[0] = 0x00;															//#
		spi_data[1] = 0x0F;															//#
		spi_data[2] = 0x0C;															//#
		spi_data[3] = 0x02;															//#
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low								//#
		for (i=0;i<4;i++)															//#
			{																		//#     SETTING TX BUFFER SIZE
				SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#
			}																		//#

		DELAY_US(29);																//#
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;											//#
													//#
		DELAY_US(10);


// reading TX_FSR

				TX_RD[0] = 0x00;
				TX_RD[1] = 0x20;
				TX_RD[2] = 0x08;
				TX_RD[3] = 0x00;
				GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
				for(i=0;i<4;i++)
					{
						SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
					}
				DELAY_US(29);
				GpioDataRegs.GPBSET.bit.GPIO57 = 1;
				tx_fsr = (SpiaRegs.SPIDAT)<<8;
				DELAY_US(10);


// reading ttx_fsr

				TX_RD[0] = 0x00;
				TX_RD[1] = 0x21;
				TX_RD[2] = 0x08;
				TX_RD[3] = 0x00;
				GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
				for(i=0;i<4;i++)
					{
						SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
					}
				DELAY_US(29);
				GpioDataRegs.GPBSET.bit.GPIO57 = 1;
				tx_fsr1 = (SpiaRegs.SPIDAT);
				DELAY_US(10);

	tx_fsrval = tx_fsr + tx_fsr1;


// reading tx_RD1

		TX_RD[0] = 0x00;
		TX_RD[1] = 0x22;
		TX_RD[2] = 0x08;
		TX_RD[3] = 0x00;
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
		for(i=0;i<4;i++)
			{
				SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
			}
		DELAY_US(29);
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;
		tx_rD = (SpiaRegs.SPIDAT)<<8;
		DELAY_US(10);


// reading tx_RD2

		TX_RD[0] = 0x00;
		TX_RD[1] = 0x23;
		TX_RD[2] = 0x08;
		TX_RD[3] = 0x00;
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
		for(i=0;i<4;i++)
			{
				SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
			}
		DELAY_US(29);
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;
		tx_rD1 = SpiaRegs.SPIDAT;
		DELAY_US(10);

		tx_rDval = tx_rD + tx_rD1 ;                                         //value of TX_RD (offset address)




// reading tx_WR 1||

		TX_RD[0] = 0x00;
		TX_RD[1] = 0x24;
		TX_RD[2] = 0x08;
		TX_RD[3] = 0x00;
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
		for(i=0;i<4;i++)
			{
				SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
			}
		DELAY_US(29);
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;
		tx_wr = (SpiaRegs.SPIDAT)<<8;
		DELAY_US(10);


// reading tx_WR  2||

		TX_RD[0] = 0x00;
		TX_RD[1] = 0x25;
		TX_RD[2] = 0x08;
		TX_RD[3] = 0x00;
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
		for(i=0;i<4;i++)
			{
				SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
			}
		DELAY_US(29);
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;
		tx_wr1 = SpiaRegs.SPIDAT;
		DELAY_US(10);


		tx_wrval = tx_wr + tx_wr1;       								// value of TX_RD register


tx_wr = tx_wr>>8;
tx_rD = tx_rD>>8;
//writing data to the Tx_Buffer

				Tx_buffSize[0] = tx_wr;
				Tx_buffSize[1] = tx_wr1;
				Tx_buffSize[2] = 0x14;
				Tx_buffSize[3] = 0xBB;
				Tx_buffSize[4] = 0xAA;
				Tx_buffSize[5] = 0xBB;
				/*for(i=3;i<10;i++)
				{
					Tx_buffSize[i] = 0xBB;
				}*/
				GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
				for(i=0;i<6;i++)
				{
					SpiaRegs.SPITXBUF = (Tx_buffSize[i]<<8);
				}
				DELAY_US(42);		//70 FOR 10
				GpioDataRegs.GPBSET.bit.GPIO57 = 1;


				DELAY_US(10);





//STEPS TO INCREMENT VALUE OF TX_WR ##############################################################


incr_addr = tx_wrval + 0x03;

incr_addr1 = incr_addr >>8;
incr_addr2 = incr_addr <<8;
incr_addr2 = incr_addr2 >>8;

// increment Tx_WR

		TX_WR[0] = 0x00;
		TX_WR[1] = 0x24;
		TX_WR[2] = 0x0C;
		TX_WR[3] = incr_addr1;
		TX_WR[4] = incr_addr2;
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
		for(i=0;i<5;i++)
		{
			SpiaRegs.SPITXBUF = (TX_WR[i]<<8);
		}
		DELAY_US(38);
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;


		DELAY_US(10);

		// reading tx_WR 1||

				TX_RD[0] = 0x00;
				TX_RD[1] = 0x24;
				TX_RD[2] = 0x08;
				TX_RD[3] = 0x00;
				GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
				for(i=0;i<4;i++)
					{
						SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
					}
				DELAY_US(29);
				GpioDataRegs.GPBSET.bit.GPIO57 = 1;
				tx_wr = (SpiaRegs.SPIDAT)<<8;
				DELAY_US(10);


		// reading tx_WR  2||

				TX_RD[0] = 0x00;
				TX_RD[1] = 0x25;
				TX_RD[2] = 0x08;
				TX_RD[3] = 0x00;
				GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
				for(i=0;i<4;i++)
					{
						SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
					}
				DELAY_US(29);
				GpioDataRegs.GPBSET.bit.GPIO57 = 1;
				tx_wr1 = SpiaRegs.SPIDAT;
				DELAY_US(10);


				tx_wrval = tx_wr + tx_wr1;       								// value of TX_RD register



// Send command register (Sn_CR)

		spi_data[0] = 0x00;													//#				@@@@@@@@@@
		spi_data[1] = 0x01;													//#				@  		 @
		spi_data[2] = 0x0C;													//#				@  		 @
		spi_data[3] = 0x20;													//#				@  		 @
		GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#				@  		 @
		for (i=0;i<4;i++)													//#				@  		 @
			{																//#
				SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame	//#
			}																	//#		    @  SEND  @
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#			@  		 @
				 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data	//#			@  		 @
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#			@  		 @
		DELAY_US(29);															//#			@  		 @
		GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#			@  		 @
		DELAY_US(20);															//#			@@@@@@@@@@


// command status
						 spi_data[0] = 0x00;													//#
						 spi_data[1] = 0x01;													//#
						 spi_data[2] = 0x08;													//#
						 spi_data[3] = 0x00;													//#
						 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
						 for (i=0;i<4;i++)														//#
						 {																		//#     reading status reg
							 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#     expected value (0x14) {listen}
						 }																		//#
						 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
						 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
						 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
						 DELAY_US(29);															//#
						GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
						cmd_statFinal = SpiaRegs.SPIDAT;										//#
						DELAY_US(10);


						// reading tx_WR 1||

								TX_RD[0] = 0x00;
								TX_RD[1] = 0x24;
								TX_RD[2] = 0x08;
								TX_RD[3] = 0x00;
								GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
								for(i=0;i<4;i++)
									{
										SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
									}
								DELAY_US(29);
								GpioDataRegs.GPBSET.bit.GPIO57 = 1;
								tx_wr = (SpiaRegs.SPIDAT)<<8;
								DELAY_US(10);


						// reading tx_WR  2||

								TX_RD[0] = 0x00;
								TX_RD[1] = 0x25;
								TX_RD[2] = 0x08;
								TX_RD[3] = 0x00;
								GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;
								for(i=0;i<4;i++)
									{
										SpiaRegs.SPITXBUF = (TX_RD[i]<<8);
									}
								DELAY_US(29);
								GpioDataRegs.GPBSET.bit.GPIO57 = 1;
								tx_wr1 = SpiaRegs.SPIDAT;
								DELAY_US(10);


								tx_wrval = tx_wr + tx_wr1;       								// value of TX_RD register



 while(cmd_statFinal != 0);

// close command

spi_data[0] = 0x00;													//#				@@@@@@@@@@
spi_data[1] = 0x01;													//#				@  		 @
spi_data[2] = 0x0C;													//#				@  		 @
spi_data[3] = 0x10;													//#				@  		 @
GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#				@  		 @
for (i=0;i<4;i++)													//#				@  		 @
	{																//#
		SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame	//#
	}																	//#		    @  close  @
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#			@  		 @
		 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data	//#			@  		 @
		 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#			@  		 @
DELAY_US(29);															//#			@  		 @
GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#			@  		 @
DELAY_US(20);															//#			@@@@@@@@@@


// reading interupt register

				spi_data[0] = 0x00;														//#
				spi_data[1] = 0x02;														//#
				spi_data[2] = 0x08;
				//#
				spi_data[3] = 0x00;														//#
				GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low							//#
				for (i=0;i<4;i++)														//#
					 {																	//#     reading interrupt reg
							 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame	//#     expected value (##) {listen}
					 }																	//#
						 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
						// rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data	//#
						 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
				 DELAY_US(29);															//#
				 GpioDataRegs.GPBSET.bit.GPIO57 = 1;									//#
				 int_send_stat = SpiaRegs.SPIDAT;										//#
				 DELAY_US(10);






// read RX_buff
				 spi_data[0] = 0x00;													//#
				 spi_data[1] = 0x00;													//#
				 spi_data[2] = 0x18;													//#
				 spi_data[3] = 0x00;													//#
				 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
				 for (i=0;i<4;i++)														//#
				 {																		//#     reading status reg
					 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#     expected value (0x14) {listen}
				 }																		//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
				 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
				 DELAY_US(29);															//#
				GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
				rxdata = SpiaRegs.SPIDAT;										//#
				DELAY_US(10);


				 spi_data[0] = 0x00;													//#
				 spi_data[1] = 0x00;													//#
				 spi_data[2] = 0x18;													//#
				 spi_data[3] = 0x00;													//#
				 GpioDataRegs.GPBCLEAR.bit.GPIO57 = 1;  //cs low						//#
				 for (i=0;i<4;i++)														//#
				 {																		//#     reading status reg
					 SpiaRegs.SPITXBUF = (spi_data[i]<<8);		//send frame			//#     expected value (0x14) {listen}
				 }																		//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
				 //rdata =(SpiaRegs.SPIRXBUF>>8);                //recieve data			//#
				 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	//#
				 DELAY_US(29);															//#
				GpioDataRegs.GPBSET.bit.GPIO57 = 1;										//#
				rxdata = SpiaRegs.SPIDAT;										//#
				DELAY_US(10);





				for(;;);
  loop ends(loop disabled)

} //main ends


void delay_loop()
{
    long      i;
    for (i = 0; i < 1000000; i++) {}
}

void error(void)
{
    __asm("     ESTOP0");						// Test failed
    for (;;);
}

void spi_init()
{
	SpiaRegs.SPICCR.all =0x0007;	             // Reset on, falling edge, 8-bit char bits
	SpiaRegs.SPICTL.all =0x000E;    		     // Enable master mode, normal phase,
                                                 // enable talk, and SPI int disabled.
	SpiaRegs.SPIBRR =0x001F;
	SpiaRegs.SPICCR.all =0x0087;		         // Relinquish SPI from Reset
    SpiaRegs.SPIPRI.bit.FREE = 1;                // Set so breakpoints don't disturb xmission
}

void spi_xmit(Uint16 a)
{
    SpiaRegs.SPITXBUF=a;
}

void spi_fifo_init()
{
// Initialize SPI FIFO registers
    SpiaRegs.SPIFFTX.all=0xE040;
    SpiaRegs.SPIFFRX.all=0x204f;
    SpiaRegs.SPIFFCT.all=0x00;
}




